diff --git a/src/main/java/net/minecraft/client/gui/Gui.java b/src/main/java/net/minecraft/client/gui/Gui.java
index 73c52c8db..f7256c09a 100644
--- a/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/src/main/java/net/minecraft/client/gui/Gui.java
@@ -257,15 +369,434 @@ public class Gui
         tessellator.draw();
     }
 
-    public void drawSlot(RenderEngine re, int x, int y, int argb){
-        float a = (float)(argb >> 24 & 0xff) / 255F;
-        float r = (float)(argb >> 16 & 0xff) / 255F;
-        float g = (float)(argb >> 8 & 0xff) / 255F;
-        float b = (float)(argb & 0xff) / 255F;
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/slot.png"));
+    public void drawSlot(int x, int y, int argb){
+
+        float a = Color.alphaFromInt(argb) / 255F;
+        float r = Color.redFromInt(argb) / 255F;
+        float g = Color.greenFromInt(argb) / 255F;
+        float b = Color.blueFromInt(argb) / 255F;
         GL11.glColor4f(r,g,b,a);
-        drawTexturedModalRect(x,y,0,0,18,18,18,0.0078125F);
+        drawGuiIcon(x, y, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
+    }
+
+    public void drawGuiTexture(RenderEngine re, int x, int y, int width, int height, String texture) {
+        Texture tex = re.loadTexture(texture);
+        tex.bind();
+
+        Tessellator t = Tessellator.instance;
+        if (tex.hasMeta("gui")) {
+            GuiTextureProperties properties = Objects.requireNonNull(tex.getMeta("gui", GuiTextureProperties.class));
+            switch (properties.type) {
+                case GuiTextureProperties.TYPE_STRETCH: {
+                    t.startDrawingQuads();
+                    t.addVertexWithUV(x, y + height, zLevel, 0, 1);
+                    t.addVertexWithUV(x + width, y + height, zLevel, 1, 1);
+                    t.addVertexWithUV(x + width, y, zLevel, 1, 0);
+                    t.addVertexWithUV(x, y, zLevel, 0, 0);
+                    t.draw();
+                    break;
+                }
+                case GuiTextureProperties.TYPE_TILE: {
+                    double uScale = 1d/ properties.width;
+                    double vScale = 1d/ properties.height;
+                    t.startDrawingQuads();
+                    t.addVertexWithUV(x        , y + height, zLevel, 0,              height * vScale);
+                    t.addVertexWithUV(x + width, y + height, zLevel, width * uScale, height * vScale);
+                    t.addVertexWithUV(x + width, y         , zLevel, width * uScale, 0);
+                    t.addVertexWithUV(x        , y         , zLevel, 0,              0);
+                    t.draw();
+                    break;
+                }
+                case GuiTextureProperties.TYPE_NINE_SLICE: {
+                    double uScale = 1d / properties.width;
+                    double vScale = 1d / properties.height;
+
+                    int innerWidth = properties.width - (properties.border.left + properties.border.right);
+                    int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
+                    int innerLeft = properties.border.left;
+                    int innerTop = properties.border.top;
+                    int innerRight = properties.width - properties.border.right;
+                    int innerBottom = properties.height - properties.border.bottom;
+
+                    int leftHeight = height - (properties.border.top + properties.border.bottom);
+                    int repeatsY = leftHeight / innerHeight;
+                    int remainderY = leftHeight % innerHeight;
+
+                    int topWidth = width - (properties.border.left + properties.border.right);
+                    int repeatsX = topWidth / innerWidth;
+                    int remainderX = topWidth % innerWidth;
+
+                    { // Inner
+                        for (int j = 0; j < repeatsY; j++) {
+                            drawTexturedModalRectDouble(
+                                x + innerLeft + repeatsX * innerWidth, y + innerTop + j * innerHeight,
+                                innerLeft + 1, innerTop,
+                                remainderX, innerHeight,
+                                uScale, vScale, 0.0); // Inner
+                        }
+
+                        for (int i = 0; i < repeatsX; i++) {
+                            drawTexturedModalRectDouble(
+                                x + innerLeft + i * innerWidth, y + innerTop + repeatsY * innerHeight,
+                                innerLeft, innerTop,
+                                innerWidth, remainderY,
+                                uScale, vScale, 0.0); // Inner
+                        }
+                        drawTexturedModalRectDouble(
+                            x + innerLeft + repeatsX * innerWidth, y + innerTop + repeatsY * innerHeight,
+                            innerLeft, innerTop,
+                            remainderX, remainderY,
+                            uScale, vScale, 0.0); // Inner
+
+                        for (int i = 0; i < repeatsX; i++) {
+                            for (int j = 0; j < repeatsY; j++) {
+                                drawTexturedModalRectDouble(
+                                    x + innerLeft + i * innerWidth, y + innerTop + j * innerHeight,
+                                    innerLeft, innerTop,
+                                    innerWidth, innerHeight,
+                                    uScale, vScale, 0.0); // Inner
+                            }
+                        }
+                    }
+
+                    { // Left Right
+                        for (int i = 0; i < repeatsY; i++) {
+                            drawTexturedModalRectDouble(
+                                x, y + innerTop + i * innerHeight,
+                                0, innerTop,
+                                innerLeft, innerHeight,
+                                uScale, vScale, 0); // left
+
+                            drawTexturedModalRectDouble(
+                                x + width - properties.border.right, y + innerTop + i * innerHeight,
+                                innerRight, innerTop,
+                                innerLeft, innerHeight,
+                                uScale, vScale, 0); // right
+                        }
+
+                        drawTexturedModalRectDouble(
+                            x, y + innerTop + repeatsY * innerHeight,
+                            0, innerTop,
+                            innerLeft, remainderY,
+                            uScale, vScale, 0); // left
+
+                        drawTexturedModalRectDouble(
+                            x + width - properties.border.right, y + innerTop + repeatsY * innerHeight,
+                            innerRight, innerTop,
+                            innerLeft, remainderY,
+                            uScale, vScale, 0); // right
+                    }
+                    { // Top Bottom
+                        for (int i = 0; i < repeatsX; i++) {
+                            drawTexturedModalRectDouble(
+                                x + innerLeft + i * innerWidth, y,
+                                innerLeft, 0,
+                                innerWidth, properties.border.top,
+                                uScale, vScale, 0); // top
+
+                            drawTexturedModalRectDouble(
+                                x + innerLeft + i * innerWidth, y + height - properties.border.bottom,
+                                innerLeft, innerBottom,
+                                innerWidth, properties.border.bottom,
+                                uScale, vScale, 0); // bottom
+                        }
+
+                        drawTexturedModalRectDouble(
+                            x + innerLeft + repeatsX * innerWidth, y,
+                            innerLeft, 0,
+                            remainderX, properties.border.top,
+                            uScale, vScale, 0); // top
+
+                        drawTexturedModalRectDouble(
+                            x + innerLeft + repeatsX * innerWidth, y + height - properties.border.bottom,
+                            innerLeft, innerBottom,
+                            remainderX, properties.border.bottom,
+                            uScale, vScale, 0); // bottom
+                    }
+
+                    drawTexturedModalRectDouble(
+                        x, y,
+                        0, 0,
+                        properties.border.left, properties.border.top,
+                        uScale, vScale, 0); // top-left
+
+                    drawTexturedModalRectDouble(
+                        x + width - properties.border.right, y,
+                        innerRight, 0,
+                        properties.border.right, properties.border.top,
+                        uScale, vScale, 0); // top-right
+
+                    drawTexturedModalRectDouble(
+                        x, y + height - properties.border.bottom,
+                        0, innerBottom,
+                        properties.border.left, properties.border.bottom,
+                        uScale, vScale, 0); // bottom-left
+
+                    drawTexturedModalRectDouble(
+                        x + width - properties.border.right, y + height - properties.border.bottom,
+                        innerRight, innerBottom,
+                        properties.border.right, properties.border.bottom,
+                        uScale, vScale, 0); // bottom-right
+
+                    break;
+                }
+            }
+        } else {
+            t.startDrawingQuads();
+            t.addVertexWithUV(x        , y + height, zLevel, 0, 1);
+            t.addVertexWithUV(x + width, y + height, zLevel, 1, 1);
+            t.addVertexWithUV(x + width, y         , zLevel, 1, 0);
+            t.addVertexWithUV(x        , y         , zLevel, 0, 0);
+            t.draw();
+        }
+    }
+
+    public void drawGuiIcon(int x, int y, int width, int height, IconCoordinate coordinate) {
+        drawGuiIconDouble(x, y, width, height, coordinate);
+    }
+    public void drawGuiIconDouble(double x, double y, double width, double height, IconCoordinate coordinate) {
+        coordinate.parentAtlas.bind();
+        Tessellator t = Tessellator.instance;
+        if (coordinate.hasMeta("gui")) {
+            GuiTextureProperties properties = Objects.requireNonNull(coordinate.getMeta("gui", GuiTextureProperties.class));
+            switch (properties.type) {
+                case GuiTextureProperties.TYPE_STRETCH: {
+                    t.startDrawingQuads();
+                    t.addVertexWithUV(x,            y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
+                    t.addVertexWithUV(x + width,    y + height, zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
+                    t.addVertexWithUV(x + width,    y,          zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
+                    t.addVertexWithUV(x,            y,          zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
+                    t.draw();
+                    break;
+                }
+                case GuiTextureProperties.TYPE_TILE: {
+                    int repeatsY = MathHelper.floor(height / properties.height);
+                    double remainderY = height % properties.height;
+
+                    int repeatsX = MathHelper.floor(width / properties.width);
+                    double remainderX = width % properties.width;
+
+                    for (int i = 0; i < repeatsX; i++) {
+                        for (int j = 0; j < repeatsY; j++) {
+                            drawIconTextureDouble(
+                                x + properties.width * i, y + properties.height * j,
+                                x + properties.width * (i + 1), y + properties.height * (j + 1),
+                                0, 0,
+                                properties.width, properties.height,
+                                coordinate);
+                        }
+                    }
+
+                    for (int j = 0; j < repeatsY; j++) {
+                        drawIconTextureDouble(
+                            x + properties.width * repeatsX, y + properties.height * j,
+                            x + properties.width * repeatsX + remainderX, y + properties.height * (j + 1),
+                            0, 0,
+                            remainderX, properties.height,
+                            coordinate);
+                    }
+
+                    for (int i = 0; i < repeatsX; i++) {
+                        drawIconTextureDouble(
+                            x + properties.width * i, y + properties.height * repeatsY,
+                            x + properties.width * (i + 1), y + properties.height * repeatsY + remainderY,
+                            0, 0,
+                            properties.width, remainderY,
+                            coordinate);
+                    }
+
+                    drawIconTextureDouble(
+                        x + properties.width * repeatsX, y + properties.height * repeatsY,
+                        x + properties.width * repeatsX + remainderX, y + properties.height * repeatsY + remainderY,
+                        0, 0,
+                        remainderX, remainderY,
+                        coordinate);
+
+                    break;
+                }
+                case GuiTextureProperties.TYPE_NINE_SLICE: {
+                    int innerWidth = properties.width - (properties.border.left + properties.border.right);
+                    int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
+                    int innerLeft = properties.border.left;
+                    int innerTop = properties.border.top;
+                    int innerRight = properties.width - properties.border.right;
+                    int innerBottom = properties.height - properties.border.bottom;
+
+                    double leftHeight = height - (properties.border.top + properties.border.bottom);
+                    int repeatsY = MathHelper.floor(leftHeight / innerHeight);
+                    double remainderY = leftHeight % innerHeight;
+
+                    double topWidth = width - (properties.border.left + properties.border.right);
+                    int repeatsX = MathHelper.floor(topWidth / innerWidth);
+                    double remainderX = topWidth % innerWidth;
+
+
+                    { // Inner
+                        for (int j = 0; j < repeatsY; j++) {
+                            drawIconTextureDouble(
+                                x + innerLeft + repeatsX * innerWidth, y + innerTop + j * innerHeight,
+                                x + innerLeft + repeatsX * innerWidth + remainderX, y + innerTop + j * innerHeight + innerHeight,
+                                innerLeft, innerTop,
+                                innerLeft + remainderX, innerTop + innerHeight,
+                                coordinate);
+                        }
+
+                        for (int i = 0; i < repeatsX; i++) {
+                            drawIconTextureDouble(
+                                x + innerLeft + i * innerWidth, y + innerTop + repeatsY * innerHeight,
+                                x + innerLeft + i * innerWidth + innerWidth, y + innerTop + repeatsY * innerHeight + remainderY,
+                                innerLeft, innerTop,
+                                innerLeft + innerWidth, innerTop + remainderY, coordinate);
+                        }
+                        drawIconTextureDouble(
+                            x + innerLeft + repeatsX * innerWidth, y + innerTop + repeatsY * innerHeight,
+                            x + innerLeft + repeatsX * innerWidth + remainderX, y + innerTop + repeatsY * innerHeight + remainderY,
+                            innerLeft, innerTop,
+                            innerLeft + remainderX, innerTop + remainderY, coordinate);
+
+                        for (int i = 0; i < repeatsX; i++) {
+                            for (int j = 0; j < repeatsY; j++) {
+                                final double xMin = (x + innerLeft) + i * innerWidth;
+                                final double yMin = (y + innerTop) + j * innerHeight;
+                                drawIconTextureDouble(
+                                    xMin, yMin,
+                                    xMin + innerWidth, yMin + innerHeight,
+                                    innerLeft, innerTop,
+                                    innerLeft + innerWidth, innerTop + innerHeight,
+                                    coordinate);
+                            }
+                        }
+                    }
+
+                    { // Left Right
+                        for (int i = 0; i < repeatsY; i++) {
+                            drawIconTextureDouble(
+                                x, y + innerTop + i * innerHeight,
+                                x + innerLeft, y + innerTop + i * innerHeight + innerHeight,
+                                0, innerTop,
+                                innerLeft, innerTop + innerHeight,
+                                coordinate);
+
+                            drawIconTextureDouble(
+                                x + width - properties.border.right, y + innerTop + i * innerHeight,
+                                x + width, y + innerTop + i * innerHeight + innerHeight,
+                                innerRight, innerTop,
+                                innerRight + properties.border.right, innerTop + innerHeight,
+                                coordinate);
+                        }
+
+                        drawIconTextureDouble(
+                            x, y + innerTop + repeatsY * innerHeight,
+                            x + innerLeft, y + innerTop + repeatsY * innerHeight + remainderY,
+                            0, innerTop,
+                            innerLeft, innerTop + remainderY,
+                            coordinate);
+
+                        drawIconTextureDouble(
+                            x + width - properties.border.right, y + innerTop + repeatsY * innerHeight,
+                            x + width, y + innerTop + repeatsY * innerHeight + remainderY,
+                            innerRight, innerTop,
+                            innerRight + properties.border.right, innerTop + remainderY,
+                            coordinate);
+                    }
+                    { // Top Bottom
+                        for (int i = 0; i < repeatsX; i++) {
+                            drawIconTextureDouble(x + innerLeft + i * innerWidth, y,
+                                x + innerLeft + i * innerWidth + innerWidth, y + properties.border.top,
+                                innerLeft, 0,
+                                innerLeft + innerWidth, properties.border.top,
+                                coordinate);
+
+                            drawIconTextureDouble(
+                                x + innerLeft + i * innerWidth, y + height - properties.border.bottom,
+                                x + innerLeft + i * innerWidth + innerWidth, y + height,
+                                innerLeft, innerBottom,
+                                innerLeft + innerWidth, innerBottom + properties.border.bottom,
+                                coordinate);
+                        }
+
+                        drawIconTextureDouble(
+                            x + innerLeft + repeatsX * innerWidth, y,
+                            x + innerLeft + repeatsX * innerWidth + remainderX, y + properties.border.top,
+                            innerLeft, 0,
+                            innerLeft + remainderX, properties.border.top,
+                            coordinate);
+
+                        drawIconTextureDouble(
+                            x + innerLeft + repeatsX * innerWidth, y + height - properties.border.bottom,
+                            x + innerLeft + repeatsX * innerWidth + remainderX, y + height,
+                            innerLeft, innerBottom,
+                            innerLeft + remainderX, innerBottom + properties.border.bottom,
+                            coordinate);
+                    }
+
+                    drawIconTextureDouble(
+                        x, y,
+                        x + properties.border.left, y + properties.border.top,
+                        0, 0,
+                        properties.border.left, properties.border.top, coordinate);
+                    drawIconTextureDouble(
+                        x, y + height - properties.border.bottom,
+                        x + properties.border.left, y + height,
+                        0, innerBottom,
+                        properties.border.left, innerBottom + properties.border.bottom, coordinate);
+
+                    drawIconTextureDouble(
+                        x + width - properties.border.right, y,
+                        x + width, y + properties.border.top,
+                        innerRight, 0,
+                        innerRight + properties.border.right, properties.border.top, coordinate);
+                    drawIconTextureDouble(
+                        x + width - properties.border.right, y + height - properties.border.bottom,
+                        x + width, y + height,
+                        innerRight, innerBottom,
+                        innerRight + properties.border.right, innerBottom + properties.border.bottom, coordinate);
+
+
+                    break;
+                }
+            }
+        } else {
+            drawIconTextureDouble(x, y, x + width, y + height, 0, 0, coordinate.width, coordinate.height, coordinate);
+        }
+    }
+
+    public void drawIconTexture(int x0, int y0, int x1, int y1, int u0, int v0, int u1, int v1, IconCoordinate coordinate) {
+        coordinate.parentAtlas.bind();
+
+        double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
+        double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
+        double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
+        double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
+
+//        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
+
+        Tessellator t = Tessellator.instance;
+        t.startDrawingQuads();
+        t.addVertexWithUV(x0, y1, zLevel, realU0, realV1);
+        t.addVertexWithUV(x1, y1, zLevel, realU1, realV1);
+        t.addVertexWithUV(x1, y0, zLevel, realU1, realV0);
+        t.addVertexWithUV(x0, y0, zLevel, realU0, realV0);
+        t.draw();
+    }
+
+    public void drawIconTextureDouble(double x0, double y0, double x1, double y1, double u0, double v0, double u1, double v1, IconCoordinate coordinate) {
+        coordinate.parentAtlas.bind();
+
+        double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
+        double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
+        double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
+        double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
+
+//        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
 
+        Tessellator t = Tessellator.instance;
+        t.startDrawingQuads();
+        t.addVertexWithUV(x0, y1, zLevel, realU0, realV1);
+        t.addVertexWithUV(x1, y1, zLevel, realU1, realV1);
+        t.addVertexWithUV(x1, y0, zLevel, realU1, realV0);
+        t.addVertexWithUV(x0, y0, zLevel, realU0, realV0);
+        t.draw();
     }
 
     public float zLevel;
diff --git a/src/main/java/net/minecraft/client/gui/GuiButton.java b/src/main/java/net/minecraft/client/gui/GuiButton.java
index 6f06d42f6..971d65a90 100644
--- a/src/main/java/net/minecraft/client/gui/GuiButton.java
+++ b/src/main/java/net/minecraft/client/gui/GuiButton.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -11,12 +13,18 @@ import net.minecraft.core.util.helper.Listener;
 
 public class GuiButton extends Gui implements GuiElement
 {
+    public static final int STATE_DISABLED = 0;
+    public static final int STATE_DEFAULT = 1;
+    public static final int STATE_HOVERED = 2;
 
     public int width;
     public int height;
     public int xPosition;
     public int yPosition;
     public String displayString;
+    public IconCoordinate defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button");
+    public IconCoordinate hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button_highlighted");
+    public IconCoordinate disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button_disabled");
     public int id;
     public boolean enabled;
     public boolean visible;
@@ -40,16 +48,23 @@ public class GuiButton extends Gui implements GuiElement
         displayString = text;
     }
 
+    public GuiButton setTextures(String defaultTexture, String hoveredTexture, String disabledTexture) {
+        this.defaultTexture = TextureRegistry.getTexture(defaultTexture);
+        this.hoveredTexture = TextureRegistry.getTexture(hoveredTexture);
+        this.disabledTexture = TextureRegistry.getTexture(disabledTexture);
+        return this;
+    }
+
     protected int getButtonState(boolean hovered)
     {
-        int state = 1;
+        int state = STATE_DEFAULT;
         if(!enabled)
         {
-            state = 0;
+            state = STATE_DISABLED;
         }
         else if(hovered)
         {
-            state = 2;
+            state = STATE_HOVERED;
         }
         return state;
     }
@@ -62,10 +77,20 @@ public class GuiButton extends Gui implements GuiElement
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
 
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        drawTexturedModalRect(xPosition, yPosition, 0, 46 + state * 20, width / 2, height);
-        drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 46 + state * 20, width / 2, height);
+        IconCoordinate tex;
+        switch (state) {
+            case STATE_DISABLED:
+                tex = disabledTexture;
+                break;
+            case STATE_HOVERED:
+                tex = hoveredTexture;
+                break;
+            case STATE_DEFAULT:
+            default:
+                tex = defaultTexture;
+        }
+        drawGuiIcon(xPosition, yPosition, width, height, tex);
 
         mouseDragged(mc, mouseX, mouseY);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiChat.java b/src/main/java/net/minecraft/client/gui/GuiChat.java
index 7961affb1..5a17db6d0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiChat.java
+++ b/src/main/java/net/minecraft/client/gui/GuiChat.java
@@ -51,9 +51,9 @@ public class GuiChat extends GuiScreen implements ITextField {
 		if (dWheel != 0)
 		{
 			if (showEmotePicker) {
-				emotePicker.scrollOffset(-dWheel / 10);
+				emotePicker.scrollOffset((int)(-dWheel / 0.1f));
 			} else {
-				mc.ingameGUI.chatScroll += dWheel / 100;
+				mc.ingameGUI.chatScroll += dWheel / 1;
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/client/gui/GuiChest.java b/src/main/java/net/minecraft/client/gui/GuiChest.java
index 55075fdce..f77122fad 100644
--- a/src/main/java/net/minecraft/client/gui/GuiChest.java
+++ b/src/main/java/net/minecraft/client/gui/GuiChest.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.core.player.inventory.ContainerChest;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.menu.ContainerMenu;
+import net.minecraft.core.player.inventory.container.Container;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
@@ -11,32 +11,31 @@ import org.lwjgl.opengl.GL11;
 public class GuiChest extends GuiContainer
 {
 
-    public GuiChest(IInventory iinventory, IInventory iinventory1)
+    public GuiChest(Container iinventory, Container iinventory1)
     {
-        super(new ContainerChest(iinventory, iinventory1));
+        super(new ContainerMenu(iinventory, iinventory1));
         inventoryRows = 0;
         upperChestInventory = iinventory;
         lowerChestInventory = iinventory1;
         allowIngameInput = false;
         char c = '\336';
         int i = c - 108;
-        inventoryRows = iinventory1.getSizeInventory() / 9;
+        inventoryRows = iinventory1.getContainerSize() / 9;
         ySize = i + inventoryRows * 18;
     }
 
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        fontRenderer.drawString(lowerChestInventory.getInvName(), 8, 6, 0x404040);
-        fontRenderer.drawString(upperChestInventory.getInvName(), 8, (ySize - 96) + 2, 0x404040);
+        fontRenderer.drawString(lowerChestInventory.getName(), 8, 6, 0x404040);
+        fontRenderer.drawString(upperChestInventory.getName(), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
-        int i = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/container.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/container.png").bind();
         int x = (width - xSize) / 2;
         int y = (height - ySize) / 2;
         
@@ -53,7 +52,7 @@ public class GuiChest extends GuiContainer
         drawTexturedModalRect(x, y + inventoryRows * 18 + 17, 0, 126, xSize, 96);
     }
 
-    private IInventory upperChestInventory;
-    private IInventory lowerChestInventory;
+    private Container upperChestInventory;
+    private Container lowerChestInventory;
     private int inventoryRows;
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiClickableLabel.java b/src/main/java/net/minecraft/client/gui/GuiClickableLabel.java
index 5f1144053..2a65551bf 100644
--- a/src/main/java/net/minecraft/client/gui/GuiClickableLabel.java
+++ b/src/main/java/net/minecraft/client/gui/GuiClickableLabel.java
@@ -33,7 +33,6 @@ public class GuiClickableLabel extends GuiButton
             return;
         }
         FontRenderer fontrenderer = mc.fontRenderer;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         boolean hovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         width = fontrenderer.getStringWidth(displayString) + 4;
